src/Entity/Modules.php
<?php

namespace App\Entity;

use App\Repository\ModulesRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: ModulesRepository::class)]
class Modules
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 100)]
    private ?string $name = null;

    #[ORM\Column(length: 255)]
    private ?string $description = null;

    #[ORM\Column(nullable: true)]
    private ?bool $is_default = null;

    #[ORM\ManyToMany(targetEntity: Partners::class, mappedBy: 'modules')]
    private Collection $partners;

    #[ORM\ManyToMany(targetEntity: Structures::class, mappedBy: 'modules')]
    private Collection $structures;

    #[ORM\Column]
    private ?bool $is_active = null;

    public function __construct()
    {
        $this->partners = new ArrayCollection();
        $this->structures = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function isIsDefault(): ?bool
    {
        return $this->is_default;
    }

    public function setIsDefault(?bool $is_default): self
    {
        $this->is_default = $is_default;

        return $this;
    }

    /**
     * @return Collection<int, Partners>
     */
    public function getPartners(): Collection
    {
        return $this->partners;
    }

    public function addPartner(Partners $partner): self
    {
        if (!$this->partners->contains($partner)) {
            $this->partners->add($partner);
            $partner->addModule($this);
        }

        return $this;
    }

    public function removePartner(Partners $partner): self
    {
        if ($this->partners->removeElement($partner)) {
            $partner->removeModule($this);
        }

        return $this;
    }

    //on va passer l'objet en string
    public function __toString(): string
        {
            return (string) $this->name;
        }

    /**
     * @return Collection<int, Structures>
     */
    public function getStructures(): Collection
    {
        return $this->structures;
    }

    public function addStructure(Structures $structure): self
    {
        if (!$this->structures->contains($structure)) {
            $this->structures->add($structure);
            $structure->addModule($this);
        }

        return $this;
    }

    public function removeStructure(Structures $structure): self
    {
        if ($this->structures->removeElement($structure)) {
            $structure->removeModule($this);
        }

        return $this;
    }

    public function isIsActive(): ?bool
    {
        return $this->is_active;
    }

    public function setIsActive(bool $is_active): self
    {
        $this->is_active = $is_active;

        return $this;
    }
    
}

src/Form/ModulesType.php
<?php

namespace App\Form;

use App\Entity\Modules;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ModulesType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('name')
            ->add('description')
            ->add('is_default')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Modules::class,
        ]);
    }
}

src/Controller/ModulesController.php
<?php

namespace App\Controller;

use App\Entity\Modules;
use App\Form\ModulesType;
use App\Repository\ModulesRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('admin/modules')]
class ModulesController extends AbstractController
{
    #[Route('/', name: 'app_modules_index', methods: ['GET'])]
    public function index(ModulesRepository $modulesRepository): Response
    {
        return $this->render('modules/index.html.twig', [
            'modules' => $modulesRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'app_modules_new', methods: ['GET', 'POST'])]
    public function new(Request $request, ModulesRepository $modulesRepository): Response
    {
        $module = new Modules();
        $form = $this->createForm(ModulesType::class, $module);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $modulesRepository->add($module, true);

            return $this->redirectToRoute('app_modules_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('modules/new.html.twig', [
            'module' => $module,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_modules_show', methods: ['GET'])]
    public function show(Modules $module): Response
    {
        return $this->render('modules/show.html.twig', [
            'module' => $module,
        ]);
    }

    #[Route('/{id}/edit', name: 'app_modules_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Modules $module, ModulesRepository $modulesRepository): Response
    {
        $form = $this->createForm(ModulesType::class, $module);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $modulesRepository->add($module, true);

            return $this->redirectToRoute('app_modules_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('modules/edit.html.twig', [
            'module' => $module,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_modules_delete', methods: ['POST'])]
    public function delete(Request $request, Modules $module, ModulesRepository $modulesRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$module->getId(), $request->request->get('_token'))) {
            $modulesRepository->remove($module, true);
        }

        return $this->redirectToRoute('app_modules_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/modules/_delete_form.html.twig
<form method="post" action="{{ path('app_modules_delete', {'id': module.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ module.id) }}">
    <button class="btn btn-danger">Supprimer le module</button>
</form>

templates/modules/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn save mt-4 mb-4">{{ button_label|default('Sauvegarder') }}</button>
{{ form_end(form) }}

templates/modules/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Éditer le Module{% endblock %}

{% block body %}
    <h1>Éditer le Module</h1>

    {{ include('modules/_form.html.twig', {'button_label': 'Mettre à jour'}) }}

    <div class="pt-4">
        <i class="fa-solid fa-circle-arrow-left pl-3"></i>
        <a href="{{ path('app_modules_index') }}">Revenir à la liste</a>
    </div>

    {{ include('modules/_delete_form.html.twig') }}
{% endblock %}

templates/modules/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Liste des Modules{% endblock %}

{% block body %}
    <h1 class="py-5">Liste des Modules</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Name</th>
                <th>Description</th>
                <th>Est activé par défaut</th>
                 <th>Voir</th>
                <th>Modifier</th>
                <th>Supprimer</th>
            </tr>
        </thead>
        <tbody>
        {% for module in modules %}
            <tr>
                <td>{{ module.id }}</td>
                <td>{{ module.name }}</td>
                <td>{{ module.description }}</td>
                <td>{{ module.isDefault ? 'Oui' : 'Non' }}</td>
                {# <td>
                    <a href="{{ path('app_modules_show', {'id': module.id}) }}">Voir</a>
                    <a href="{{ path('app_modules_edit', {'id': module.id}) }}">Modifier</a>
                </td> #}
                <td class="text-center">
                    <a href="{{ path('app_modules_show', {'id': module.id}) }}"<i class="fa-solid fa-eye blue"></i> </a>
                </td>
                <td class="text-center">
                    <a href="{{ path('app_modules_edit', {'id': module.id}) }}"><i class="fa-solid fa-pen purple"></i></a>
                </td>
                <td class="text-center">
                    <a href="{{ path('app_modules_delete', {'id': module.id}) }}"><i class="fa-solid fa-trash-can red"></i></a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">Aucun résultat trouvé</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
    
    <a href="{{ path('app_modules_new') }}"><i class="fa-solid fa-plus green"></i> Créer un nouveau module</a>

{% endblock %}

templates/modules/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Créer un nouveau module{% endblock %}

{% block body %}
    <h1>Créer un nouveau Module</h1>

    {{ include('modules/_form.html.twig') }}

    <a href="{{ path('app_modules_index') }}">Revenir à la liste</a>
{% endblock %}

templates/modules/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Modules{% endblock %}

{% block body %}
    <h1>Modules</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Nom</th>
                <td>{{ module.name }}</td>
            </tr>
            <tr>
                <th>Description</th>
                <td>{{ module.description }}</td>
            </tr>
            <tr>
                <th>Est activé par défaut</th>
                <td>{{ module.isDefault ? 'Oui' : 'Non' }}</td>
            </tr>
        </tbody>
    </table>

    <div>
        <button class="btn modify-button mt-4"><a href="{{ path('app_modules_edit', {'id': module.id}) }}">Modifier</a></button>
    </div>
    <div class="pt-4">
        <i class="fa-solid fa-circle-arrow-left pl-3"></i>
        <a href="{{ path('app_modules_index') }}">Revenir à la liste</a>
    </div>
{# 
    <a href="{{ path('app_modules_index') }}">Revenir à la liste</a>

    <a href="{{ path('app_modules_edit', {'id': module.id}) }}">Éditer</a> #}

    {{ include('modules/_delete_form.html.twig') }}
{% endblock %}